# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages

stages:          # List of stages for jobs, and their order of execution
  - build
  - bridge
  - complete

variables:
  MODULE: "zip"
  EXCLUDE: "none"

start:       # This job runs in the build stage, which runs first.
  stage: build
  script:
    - echo "Start"

bridge-aws3:   
  stage: bridge 
  rules:
    - if: ($MODULE == "All" || "aws3" =~ $MODULE) && "aws3" !~ $EXCLUDE
      when: always
  trigger:   
    project: drb-python/impl/aws3
    branch: main
    strategy: depend

bridge-era5:
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "era5" =~ $MODULE) && "era5" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/era5
    branch: main
    strategy: depend

bridge-eurostat:
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "eurostat" =~ $MODULE) && "eurostat" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/eurostat
    branch: main
    strategy: depend

bridge-file:
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "file" =~ $MODULE) && "file" !~ $EXCLUDE
      when: always   
  trigger:
    project: drb-python/impl/file
    branch: main
    strategy: depend

bridge-ftp:
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "ftp" =~ $MODULE) && "ftp" !~ $EXCLUDE
      when: always   
  trigger:
    project: drb-python/impl/ftp
    branch: main
    strategy: depend

bridge-grib:
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "grib" =~ $MODULE) && "grib" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/grib
    branch: main
    strategy: depend

bridge-http:   
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "http" =~ $MODULE) && "http" !~ $EXCLUDE
      when: always  
  trigger:
    project: drb-python/impl/http
    branch: main
    strategy: depend

bridge-image:  
  stage: bridge  
  rules:
    - if: ($MODULE == "All" || "image" =~ $MODULE) && "image" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/image
    branch: main
    strategy: depend

bridge-java:  
  stage: bridge  
  rules:
    - if: ($MODULE == "All" || "java" =~ $MODULE) && "java" !~ $EXCLUDE
      when: always   
  trigger:
    project: drb-python/impl/java
    branch: main
    strategy: depend

bridge-json:  
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "json" =~ $MODULE) && "json" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/json
    branch: main
    strategy: depend


bridge-netcdf:   
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "netcdf" =~ $MODULE) && "netcdf" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/netcdf
    branch: main
    strategy: depend

bridge-odata:   
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "odata" =~ $MODULE) && "odata" !~ $EXCLUDE
      when: always
  trigger:  
    project: drb-python/impl/odata
    branch: main
    strategy: depend


bridge-swift:   
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "swift" =~ $MODULE) && "swift" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/swift
    branch: main
    strategy: depend


bridge-tar:   
  stage: bridge   
  rules:
    - if: ($MODULE == "All" || "tar" =~ $MODULE) && "tar" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/tar
    branch: main
    strategy: depend

bridge-wcs:
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "wcs" =~ $MODULE) && "wcs" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/wcs
    branch: main
    strategy: depend

bridge-webdav:   
  stage: bridge  
  rules:
    - if: ($MODULE == "All" || "webdav" =~ $MODULE) && "webdav" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/webdav
    branch: main
    strategy: depend

bridge-wms:
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "wms" =~ $MODULE) && "wms" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/wms
    branch: main
    strategy: depend

bridge-wmts:
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "wmts" =~ $MODULE) && "wmts" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/wmts
    branch: main
    strategy: depend

bridge-wxs:
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "wxs" =~ $MODULE) && "wxs" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/wxs
    branch: main
    strategy: depend

bridge-xml: 
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "xml" =~ $MODULE) && "xml" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/xml
    branch: main
    strategy: depend

bridge-zarr: 
  stage: bridge 
  rules:
    - if: ($MODULE == "All" || "zarr" =~ $MODULE) && "zarr" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/zarr
    branch: main
    strategy: depend

bridge-zip: 
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "zip" =~ $MODULE) && "zip" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/impl/zip
    branch: main
    strategy: depend

bridge-add-ons-sentinel1:
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "sentinel1" =~ $MODULE) && "sentinel1" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/metadata/add-ons/sentinel-1
    branch: main
    strategy: depend

bridge-add-ons-sentinel2:
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "sentinel2" =~ $MODULE) && "sentinel2" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/metadata/add-ons/sentinel-2
    branch: main
    strategy: depend

bridge-add-ons-sentinel3:
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "sentinel3" =~ $MODULE) && "sentinel3" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/metadata/add-ons/sentinel-3
    branch: main
    strategy: depend

bridge-add-ons-sentinel5p:
  stage: bridge
  rules:
    - if: ($MODULE == "All" || "sentinel5p" =~ $MODULE) && "sentinel5p" !~ $EXCLUDE
      when: always
  trigger:
    project: drb-python/metadata/add-ons/sentinel-5p
    branch: main
    strategy: depend
end:       # This job runs in the build stage, which runs first.
  stage: complete
  script:
    - echo "End"


